package com.calculator;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;

import java.util.Arrays;
import java.util.Collection;

import static org.junit.Assert.assertEquals;

@RunWith(Parameterized.class)
public class ParameterizedCalculatorTest {

    Calculator paramCalc;
    int firstVal;
    int secondVal;
    int expectedSum;

    @Before
    public void init() {
        paramCalc = new Calculator();
    }

    public ParameterizedCalculatorTest(int firstVal, int secondVal, int expectedSum) {
        super();
        this.firstVal = firstVal;
        this.secondVal = secondVal;
        this.expectedSum = expectedSum;
    }

    @Parameterized.Parameters
    public static Collection sumValues() {
        return Arrays.asList(new Object[][] {
                {2, 2, 4},
                {4, 4, 8},
                {3, 4, 7},
                {10, 10, 20}
        });
    }

    @Test
    public void testSumValues() {
        System.out.println("Sum of " + firstVal + " + " + secondVal + ": " + expectedSum);
        assertEquals(expectedSum, paramCalc.add(firstVal, secondVal));
    }
}
